function CwdStudio_ccwd() {
  
  saveInterval = 5000;
  cookieDayLife = 7;
  
  var x = 1;
  var y = 1;
  var dir = 0;
  var width = 0;
  var height = 0;
  var cellCount = 0;
  var id;
  var legend;
  var crossword;
  var help;
  var specChar = new Array();
  
  dir_vector = new Array(new Array(1,0),new Array(0,1));
  dir_inverse = new Array(-1,1);
  
  var cells = new Array();
  var cellList = new Array();
  
  function addClass(el,cls) {
    if (el.className=='') {
      el.className = cls;
    } else {
      if (el.className.indexOf(cls)<0) {
        el.className += ' '+cls;
      }
    }
  }
  
  function removeClasses(el,cls) {
      var clses = el.className.split(' ');
      var newCls = "";
      for (var j=0;j<clses.length;j++) {
        var inArr = false;
        for (var i=0;i<cls.length;i++) {
          if (clses[j]==cls[i]) {
            inArr = true;
            break;
          }
        }
        if (!inArr) {
          if (newCls.length>0) {
            newCls += ' ';
          }
          newCls += clses[j];
        }
      }
      el.className = newCls;
  }
  
  function isClass(el,clses) {
    for (var i=0;i<clses.length;i++) {
      if (el.className.indexOf(clses[i])>=0) return true;
    }
    return false;
  }
  
  function setEvent(el,event,code) {
    if( el.attachEvent ){
       el.attachEvent(event, function() {eval(code);});
    } else {
       el.setAttribute(event, code); 
    }
  }
  
  function selectNothing() {
    for (var i=0;i<cellList.length;i++) {
      removeClasses(cellList[i],new Array('sel','hlg'));
    }
  }
  
  function selectCellInternal(cx,cy) {
    if (!cells[cy]) return;
    if (!cells[cy][cx]) return;
    x = cx;
    y = cy;
    var clueId = "";
    selectNothing();
    addClass(cells[y][x],'sel');
    cells[y][x].firstChild.focus();
    if (isClass(cells[y][x],new Array('blank','sol'))) {
      for (var i=0;i<dir_inverse.length;i++) {
        var dx = dir_vector[dir][0]*dir_inverse[i];
        var dy = dir_vector[dir][1]*dir_inverse[i];
        cx = x;
        cy = y;
        while (cells[cy+dy] && cells[cy+dy][cx+dx] && isClass(cells[cy+dy][cx+dx],new Array('blank','sol'))) {
          // kontrola hranice, pokud klikame na posledni pismeno slova, aby to nepreteklo
          if (dir_inverse[i]==1 && (dir==0 && isClass(cells[cy][cx],new Array('rB')) || dir==1 && isClass(cells[cy][cx],new Array('bB')))) break;
          cx += dx;
          cy += dy;
          // naraz zacatek slova
          if (dir_inverse[i]==-1 && (dir==0 && isClass(cells[cy][cx],new Array('rB')) || dir==1 && isClass(cells[cy][cx],new Array('bB')))) {
             clueId = id+'_clue_'+(cx-dx)+'_'+(cy-dy)+'_'+dir;
             break;
          }
          addClass(cells[cy][cx],'hlg');
          // naraz na konec slova
          if (dir==0 && isClass(cells[cy][cx],new Array('rB')) || dir==1 && isClass(cells[cy][cx],new Array('bB'))) break;
        }
        if (dir_inverse[i]==-1 && (cx==0 && dir==0 || cy==0 && dir==1)) {
          clueId = id+'_clue_'+cx+'_'+cy+'_'+dir;
        }    
      }
    } 
    
    var clue = '&nbsp;';
    var spans = legend.getElementsByTagName('span');
    for (var j=0;j<spans.length;j++) {
      spans[j].className = (spans[j].id==clueId)?'hlg':'';
      if (spans[j].id==clueId) clue = spans[j].innerHTML;
    }
    document.getElementById(id+'_clue').innerHTML = clue;
  }
    
  function inverseDirInternal() {
    if (dir==0) dir=1; else dir=0;
    selectCellInternal(x,y);
  }  
    
  function setContent(txt) {
    if (isClass(cells[y][x],new Array('blank','sol'))) {
      cells[y][x].firstChild.value = txt;
    }
  }
  
  function move(dx,dy) {
    if (cells[y+dy] && cells[y+dy][x+dx]) selectCellInternal(x+dx,y+dy);
  }
  
  function moveMargin(dx,dy) {
    var cx = x;
    var cy = y;
    while (cells[cy+dy] && cells[cy+dy][cx+dx] && isClass(cells[cy+dy][cx+dx],new Array('blank','sol'))) {
      if (dx==-1 && isClass(cells[cy+dy][cx+dx],new Array('rB'))) break;
      if (dy==-1 && isClass(cells[cy+dy][cx+dx],new Array('bB'))) break;
      if (dx==1 && isClass(cells[cy][cx],new Array('rB'))) break;
      if (dy==1 && isClass(cells[cy][cx],new Array('bB'))) break;
      cx += dx;
      cy += dy;
    }
    selectCellInternal(cx,cy);
  }

  function showHelpInternal() {
    var ww = (document.documentElement && document.documentElement.clientWidth)?document.documentElement.clientWidth:window.innerWidth;
    var wh = (document.documentElement && document.documentElement.clientHeight)?document.documentElement.clientHeight:window.innerHeight;
    help.style.display = (help.style.display=='none')?'block':'none';
    help.firstChild.style.position = 'absolute';
    help.firstChild.style.width = (ww/2)+'px';
    help.firstChild.style.height = (wh/2)+'px';
    help.firstChild.style.left = (ww/4)+'px';
    help.firstChild.style.top = (wh/4)+'px';
  }

  function save() {
    var data = '';
    for (var i=0;i<cellList.length;i++) {
      data += ','+cellList[i].firstChild.value;
    }
    data = x+","+y+","+dir+data;
    localStorage[id+'_data'] = data;
  }
  
  function load() {
    var data = localStorage[id+'_data'];
    if (data==null || data=="") return;
    var cellData = data.split(',');
    for (var i=0;i<cellList.length;i++) {
      if (cellData[i+3]) {
        if (isClass(cellList[i],new Array('blank','sol'))) {
          cellList[i].firstChild.value = cellData[i+3];
        }
      }
    }
    var cx = cellData[0];
    var cy = cellData[1];
    var cdir = cellData[2];
    if (!cx || cx===null || isNaN(cx * 1)) cx = width/2;
    if (!cy || cy===null || isNaN(cy * 1)) cy = height/2;
    if (!cdir || cdir===null || isNaN(cdir * 1)) cdir = 0;
    dir = cdir*1;
    selectCellInternal(cx*1,cy*1);
  }
  
 function helpClick(e) {
    var target = (e && e.target) || (event && event.srcElement);
    var inhelp = false;
    while (target.parentNode) {
      if (target.parentNode.className=='help') {
        inhelp = true;
        break;
      }
      target = target.parentNode;
    }
    if (!inhelp) showHelpInternal();
  }
  
  this.saveTask = function() {
    save();
    setTimeout(id+'.saveTask();',saveInterval);
  }
  
  this.selectCellDir = function(cx,cy,cdir) {
    dir = cdir;
    selectCellInternal(cx,cy);
  }
  
  this.selectCell = function(cx,cy) {
    if (x==cx && y==cy) {
      inverseDirInternal();
    } else {
      selectCellInternal(cx, cy);
    }
  }

  this.showHelp = function() {
    showHelpInternal();
  }

  this.setText = function(txt) {
    setContent(txt);
    move(dir_vector[dir][0],dir_vector[dir][1]);
  }

  this.keyDown = function(e) { 
    if (!e) e = window.event;
    var key = e.keyCode;
    
    var active = cells[y][x];
    switch (key) {
      case 8:
        setContent('');
        move(-1*dir_vector[dir][0],-1*dir_vector[dir][1]);
        return false;
      case 39:
        move(active.colSpan,0);return false;
      case 37:
        move(-1,0);return false;
      case 40:
        move(0,active.rowSpan);return false;
      case 38:
        move(0,-1);return false;
      case 46:
        setContent('');return false;
      case 36:
        moveMargin(-1*dir_vector[dir][0],-1*dir_vector[dir][1]);return false;
      case 35:
        moveMargin(dir_vector[dir][0],dir_vector[dir][1]);return false;
      case 33:
        move(-1*dir_vector[(dir==1)?0:1][0],-1*dir_vector[(dir==1)?0:1][1]);
        moveMargin(-1*dir_vector[dir][0],-1*dir_vector[dir][1]);
        return false;
      case 34:
        move(dir_vector[(dir==1)?0:1][0],dir_vector[(dir==1)?0:1][1]);
        moveMargin(-1*dir_vector[dir][0],-1*dir_vector[dir][1]);
        return false;
      case 32:
        inverseDirInternal();
        return false;
      case 27:
        showHelpInternal();
        e.preventDefault();
        return false;
      case 78:case 110:
        if (e.ctrlKey && e.shiftKey) {
          for (var i=0;i<cellList.length;i++) {
            if (isClass(cellList[i],new Array('blank','sol'))) {
              cellList[i].firstChild.value = '';
            }
          }
          e.preventDefault();
          return false;
        }
        break;
    }
    return true;
  }

  this.addSpecialChar = function(data,visual) {
    specChar[specChar.length] = new Array(data,visual);
  }
  
  this.inverseDir = function() {
    inverseDirInternal();
  }
  
  this.init = function(initId) {
    id = initId;
    let ref = this;
    var div = document.getElementById(id);
    var table = div.getElementsByTagName('table')[0];
    var trs = table.getElementsByTagName('tr');
    
    var inDivs = div.getElementsByTagName('div');
    for (var i=0;i<inDivs.length;i++) {
      if (inDivs[i].className=="legend") legend = inDivs[i];
      if (inDivs[i].className=="crossword") crossword = inDivs[i];
      if (inDivs[i].className=="help") help = inDivs[i];
    }
    
    height = 0;
    for (var y=1;y<trs.length;y++) {
      cells[height] = new Array();
      var cx = 0;
      var tds = trs[y].getElementsByTagName('td');
      for (var x=1;x<tds.length;x++) {
        
        while (typeof(cells[y-1][cx])!="undefined") cx++;
        cellList[cellCount++] = tds[x];
        
        for (var yy=0;yy<tds[x].rowSpan;yy++) {
          for (var xx=0;xx<tds[x].colSpan;xx++) {
            cells[y+yy-1][cx+xx] = tds[x];
          }
        } 
        const selx = cx;
        const sely = y-1;
        tds[x].onpointerdown = function() {ref.selectCell(selx,sely);};
        tds[x].firstChild.oninput = function (e) {
          let text = this.value.toUpperCase();
          for (let i=0;i<specChar.length;i++) {
            if (specChar[i][0]===text) {
              ref.setText(specChar[i][1]);
              return false;
            } else if (specChar[i][1]===text) {
              ref.setText(text);
              return false;
            }
          }
          if (text.length>=1) {
            ref.setText(text.substr(text.length-1));
            return false;
          }
        };
        cx += tds[x].colSpan;
        if (cx>width) width = cx;
                
      }
      height++;
    }
    
    var legSpans = legend.getElementsByTagName('span');
    for (var i=0;i<legSpans.length;i++) {
      var reres = legSpans[i].id.match(id+'_clue_([0-9]+)_([0-9]+)_([0-1])');
      if (reres) {
        var ndir = reres[3]*1;
        var nx = reres[1]*1;
        var ny = reres[2]*1;
        setEvent(legSpans[i],'onclick',id+'.selectCellDir('+nx+','+ny+','+ndir+');');
      } 
    }
    
    help.innerHTML = '<div style="overflow:scroll;position:relative;z-index:1000;">'+help.innerHTML+'</div>';
    help.style.position = 'absolute';
    help.style.left = '0';
    help.style.top = '0';
    help.style.width = '100%';
    help.style.height = '100%';
    help.style.display = 'none';
    help.onclick = helpClick;
    
    document.onkeydown=this.keyDown;
    selectCellInternal(width/2,height/2);
    crossword.style.width = ((width+1)*cells[0][0].offsetWidth)+'px';
    load();
    setTimeout(id+'.saveTask();',saveInterval);
  }

}


