function Crossword(id,data,symbol,specChars) {
    this.id = id;
	this.dirvec = [[1,0],[0,1]];
    this.dirnums = [1,-1];
    this.x = 0;
    this.y = 0;
    this.dir = 0;
	this.symbol = symbol;
	this.specChars = specChars;
	this.numcwd = false;
	this.numcwdmap = {};
	this.word = null;
	this.word_x = null;
	this.word_y = null;
	this.word_dir = null;
	
	this.getKey = function(e) {
	    if (!e) e = window.event;
		if (window.event) {
			return window.event.keyCode;
		} else {
			return e.which;
		}
	};  
	
	this.setLetter = function(num,val) {
		$('#puzzle input[num='+num+']').each(function(idx) {
			$(this).val(val);
		});
	};
	
	this.render = function() {
		var table = $("<table></table>");
		table.addClass("grid");
		for (var y=0;y<this.height;y++) {
			var tr = $("<tr></tr>");
			for (var x=0;x<this.width;x++) {
				var td = $("<td></td>");
				tr.append(td);
				var cell = this.cells[y][x];
				if (!cell || cell=='#') {
					td.addClass("symbol printed").text(this.symbol);
				} else if (cell=='!' || cell=='') {
					td.addClass("none");
				} else if (cell.match(/^\{.{1,2}\}$/)) {
					var num;
					if (this.numcwd) {
						num = cell.substring(1,cell.length-1);
						td.attr("num",num);
						td.append("<span class=\"num\">"+num+"</span>");
					}
					td.attr("id","cell_"+x+"_"+y);
					td.addClass("solution writing");
					var inp = $("<input type=\"text\" />");
					if (this.numcwd) {
						inp.attr("num",num);
					}
					td.append(inp);
				} else if ((!this.numcwd && (cell.length==1 || this.specChars.indexOf(cell)>=0)) || (this.numcwd && cell.match("^[0-9]+$")))  {
					if (this.numcwd) {
						td.attr("num",cell);
						td.append("<span class=\"num\">"+cell+"</span>");
					}
					td.attr("id","cell_"+x+"_"+y);
					td.addClass("letter writing");
					var inp = $("<input type=\"text\" />");
					if (this.numcwd) {
						inp.attr("num",cell);
					}					
					td.append(inp);
				} else {
					td.addClass("clue printed");
					var content = cell.split("|");
					switch (content.length) {
					case 1:
						if (y<this.height-1 && this.cells[y+1][x] && (this.cells[y+1][x].length==1 || this.specChars.indexOf(this.cells[y+1][x])>=0)) {
							td.append($("<div></div>").addClass("vert").text(content[0]));
						} else {
							td.append($("<div></div>").addClass("hor").text(content[0]));
						}
						break;
					case 2:
						td.append($("<div></div>").addClass("hor").text(content[0]));
						td.append($("<div></div>").addClass("vert sep").text(content[1]));
						break;
					default:
					}
				}
			}
			table.append(tr);
		}
		
		$("#puzzle").append(table);
		$("#puzzle").addClass("crossword");

		if (this.numcwd) {
			var letters = $("<div></div>");
			letters.addClass('numletters');
			for (var key in this.numcwdmap) {
				var row = $("<div></div>");
				row.append("<span>"+key+"</span>");
				var inp = $('<input type="text" maxlength="2" num="'+key+'"/>');
				inp.css('textTransform','uppercase');
				inp.keyup(function() {
					cwdref.setLetter($(this).attr("num"),$(this).val().toUpperCase());
				});
				row.append(inp);
				letters.append(row);
			}
			$("#puzzle").append(letters);
		}
			
		if (this.numcwd && this.word!=null) {
			var numCwdWord = this.word;
			var thisRef = this;
			for (var i=0;i<this.word.length;i++) {
				var x = this.word_x+this.dirvec[this.word_dir][0]*i;
				var y = this.word_y+this.dirvec[this.word_dir][1]*i;
				$("#cell_"+x+"_"+y+">input").each(function (e) {
					$(this).val(numCwdWord[i]);
					$(this).addClass("fixed");
				}); 
			}
		}
			
		var cwdref = this;
		$('#puzzle td').click(function() {
		  var id = $(this).attr('id');
		  if (id && id.indexOf('cell')==0) {
				var coords = id.substring(5).split('_');
				cwdref.selectCell(parseInt(coords[0]),parseInt(coords[1]));
				return false;
		  }
		});
	$('#puzzle .grid :text').bind('keypress',function(e) {
			var key = cwdref.getKey(e);
			if (key>64) {
				var ch = String.fromCharCode(key).toUpperCase();
				cwdref.setText(ch);
				cwdref.move(1);
			}
			return false;
	  });
	  $('#puzzle .grid :text').bind('keydown',function(e) {
	        var key = cwdref.getKey(e);
			switch (key) {
			  case 8:
			    cwdref.setText('');
			    cwdref.move(-1);
			    return false;
			  case 32:
			    cwdref.selectCell(cwdref.x,cwdref.y);
				return false;
			}
			return true;
	  });
      $(document).bind('keydown',function(e) {
	     var key = cwdref.getKey(e);
		 switch (key) {
		 /*case 8:
		   return false;*/
		  case 37:
			cwdref.selectCell(cwdref.x-1,cwdref.y);
			return false;
		  case 39:
			cwdref.selectCell(cwdref.x+1,cwdref.y);
			return false;
		  case 38:
			cwdref.selectCell(cwdref.x,cwdref.y-1);
			return false;
		  case 40:
			cwdref.selectCell(cwdref.x,cwdref.y+1);
			return false;
	     }
		 return true;
      });	
	};

	this.move = function(off) {
		this.selectCell(this.x+this.dirvec[this.dir][0]*off,this.y+this.dirvec[this.dir][1]*off);
	};
		
	this.setText = function(text) {
	  var input = $('#puzzle td.selected input');
	  if (input.val()=='C' && text=='H') text = 'CH';
	  if (input.val()=='D' && (text=='Z' || text=='')) text = 'D'+text;
	  input.val(text);
	};
	
	this.selectCell = function(x,y) {
	var selCel = $('#cell_'+x+'_'+y);
	if (selCel.length==1) {
			var currentSelected = $('#cell_'+x+'_'+y).hasClass('selected');
			$('#puzzle td').removeClass('selected active');
		if (selCel.hasClass('letter') || selCel.hasClass('solution')) {
					if (currentSelected && this.x==x && this.y==y) {
						  this.dir = (this.dir+1)%2;
					}
					this.x = x;
					this.y = y;
					selCel.addClass('selected');
					if (selCel.hasClass('letter') || selCel.hasClass('solution')) {
							for (var dirnum in this.dirnums) {
									var cx = x;
									var cy = y;
									for (;;) {
										  cx+=this.dirvec[this.dir][0]*this.dirnums[dirnum];
										  cy+=this.dirvec[this.dir][1]*this.dirnums[dirnum];
										  var c = $('#cell_'+cx+'_'+cy);
										  if (c.length==1 && (c.hasClass('letter') || c.hasClass('solution'))) {
											c.addClass('active');
										  } else {
											break;
										  }
									}
								  }
								  $('#cell_'+x+'_'+y+' :text').focus();
							}

					}
					
		  }
		  return selCel;
  };

	this.load = function(data) {
		var cellData = "";
		var numbers = {};
		var mode = 0;
		var lines = data.split("\n");
		var word = [];
		for (var i=0;i<lines.length;i++) {
			var line = lines[i];
			if (line.trim().length==0) {
				mode++;
			} else {
				switch(mode) {
					case 0:
						cellData+=line+"\n";
						break;
					case 1:
						var equalsPos = line.indexOf('=');
						if (equalsPos>0) {
							var num = line.substring(0,equalsPos);
							var letter = line.substring(equalsPos+1);
							this.numcwd = true;
							this.numcwdmap[num] = letter;
						}
						break;
					case 2:
						if (line.substring(0,5)=="WORD=") {
							word = line.substring(5).split(";");
						}
						break;
				}
			}
		}
		
		
		this.cells = this.csvParse(cellData.trim());
		this.width = 0;
		this.height = this.cells.length;
		for (var y=0;y<this.height;y++) {
			var row = this.cells[y];
			if (row.length>this.width) {
				this.width = row.length;
			}
		}
		if (word.length>0) {
			this.word = word;
			for (var y=0;y<this.height;y++) {	
				for (var x=0;x<this.width;x++) {
					if (this.cells[y][x]!=null && parseInt(this.cells[y][x].replace(/[^0-9]/,""))==1) {
						var foundHor = this.width-x<=word.length;
						var foundVert = this.height-y<=word.length;
						if (foundHor) {
							for (var i=1;i<word.length;i++) {
								if (this.cells[y][x+i]==null || parseInt(this.cells[y][x+i].replace(/[^0-9]/,""))!=i+1) {
									foundHor = false;
									break;
								}
							}							
						}
						if (!foundHor && foundVert) {
							for (var i=1;i<word.length;i++) {
								if (this.cells[y+i][x]==null || parseInt(this.cells[y+i][x].replace(/[^0-9]/,""))!=i+1) {
									foundVert = false;
									break;
								}
							}														
						}
						if (foundHor || foundVert) {
							this.word_x = x;
							this.word_y = y;
							this.word_dir = (foundHor)?0:1;
						}
					}
				}
			}
		}
	};

	
	this.loadData = function(data) {
		if (data) {
			if (this.numcwd) {
				console.log(data);
				var parts = data.split("-#-");
				if (parts.length>1) {
					var numvals = parts[1].split(";");
					$('#puzzle .numletters input').each(function(idx) {		
						$(this).val(numvals[idx]);
					});
				}
				data = parts[0];
			}
			data = data.split(";");
			$('#puzzle .writing input').each(function(idx) {
				if (!$(this).hasClass("fixed")) {
					$(this).val(data[idx]);
				}
			});
		}
	};
 
	this.saveData = function() {
		var data = "";
		$('#puzzle .writing input').each(function(idx) {
		  data+=";"+$(this).val();
		});
		if (this.numcwd) {
			data+="-#-";
			var subData = "";
			$('#puzzle .numletters input').each(function(idx) {	
				subData+=";"+$(this).val();
			});
			data+=subData.substring(1);
		}
		return data.substring(1);
	};
	
	this.supports_html5_storage = function() {
		  try {
			return 'localStorage' in window && window['localStorage'] !== null;
		  } catch (e) {
			return false;
		  }
	  };	
	
	
	this.saveUserData = function() {
	  if (this.supports_html5_storage()) {
		localStorage.setItem('crossword_'+this.id,this.saveData());
	  }
	};

	this.loadUserData = function() {
	  if (this.supports_html5_storage()) {
		var data = localStorage.getItem('crossword_'+this.id);
		if (data) {
		  this.loadData(data);
		}
	  }
	};
	
	
	this.csvParse =  function (strData,strDelimiter) {
		strDelimiter = (strDelimiter || ";");
		var objPattern = new RegExp(
			(
				"(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
				"(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
				"([^\"\\" + strDelimiter + "\\r\\n]*))"
			),
			"gi"
		);

		var arrData = [[]];
		var arrMatches = null;
		while (arrMatches = objPattern.exec( strData )){
			var strMatchedDelimiter = arrMatches[ 1 ];

			if (
				strMatchedDelimiter.length &&
				(strMatchedDelimiter != strDelimiter)
				){
				arrData.push( [] );
			}

			if (arrMatches[ 2 ]){
				var strMatchedValue = arrMatches[ 2 ].replace(
					new RegExp( "\"\"", "g" ),
					"\""
					);
			} else {
				var strMatchedValue = arrMatches[ 3 ];
			}

			arrData[ arrData.length - 1 ].push( strMatchedValue );
		}

		return( arrData );
	};


	this.saveTask = function() {
		cwdref = this;
			this.saveUserData();
		  setTimeout(function() {
			cwdref.saveTask();
		  },5000);	  
	};
	
	this.load(data);
	this.render();
	this.loadUserData();
	this.saveTask();
}