function getKey(e) {
    if (window.event) {
        return window.event.keyCode;
    } else {
        return e.which;
    }
}

function CwdStudio_cwd8dv2(id,width,height) {
    this.width = width;
    this.height = height;
    this.gridSize = 28;
    this.id = id;
    this.pressed = false;
    this.x1 = -1;
    this.y1 = -1;
    this.x2 = -1;
    this.y2 = -1;
    this.state = "";
    this.saveInterval = 5000;
    this.init = function() {
        var cwdref = this;
        $(document).keydown(function(e) {
            var key = getKey(e);
            if (key==32) {
                $('#' + cwdref.id + ' table td').each(function() {
                    var td = $(this);
                    if (td.children('.cwd8d_cell:visible').length==0) {
                        td.addClass('solution');
                    }
                });
            }
        });
        $(document).keyup(function(e) {
            var key = getKey(e);
            if (key==32) {
                $('#' + cwdref.id + ' table td').removeClass('solution');
            }
        });
        var crosses = "";
        for (var i=1;i<=8;i++) {
            crosses += '<div class="cwd8d_cell cwd8d_cell'+i+'" style="display:none;"></div>';
        }
        $('#' + cwdref.id + ' table td').wrapInner('<div class="letter" />');
        $('#' + cwdref.id + ' table td').prepend(crosses);
        $('#' + cwdref.id + ' table td').bind('mousedown',function(e) {
            var id = $(this).attr('id');
            if (id.indexOf(cwdref.id)==0) {
                var coords = id.substring(cwdref.id.length+1).split('_');
                cwdref.pressed = true;
                cwdref.x1 = parseInt(coords[0]);
                cwdref.y1 =  parseInt(coords[1]);
                return false;
            }
        });
        function getTouchPosition(e) {
			e.preventDefault();
            var table = $('#' + cwdref.id + '  table');
            var x = Math.floor((e.originalEvent.touches[0].pageX-table.position().left)/cwdref.gridSize);
            var y = Math.floor((e.originalEvent.touches[0].pageY-table.position().top)/cwdref.gridSize);
            x = Math.max(Math.min(cwdref.width-1,x),0);
            y = Math.max(Math.min(cwdref.height-1,y),0);
            return [x,y];
        }
        $('#' + cwdref.id + ' table td').bind('mouseup',function(e) {
            $('#' + cwdref.id + ' table td').removeClass('striking bad good');
            if (cwdref.pressed && (Math.abs(cwdref.x1-cwdref.x2)==Math.abs(cwdref.y1-cwdref.y2) || cwdref.y1==cwdref.y2 || cwdref.x1==cwdref.x2)) {
                cwdref.cross(cwdref.x1,cwdref.y1,cwdref.x2,cwdref.y2);
            }
            cwdref.pressed = false;
        });

        $('#' + cwdref.id + ' table').bind('touchstart',function(e) {
            var pos = getTouchPosition(e);
            cwdref.pressed = true;
            cwdref.x1 = pos[0];
            cwdref.y1 =  pos[1];
            return false;
        });
        $('#' + cwdref.id + '  table').bind('touchmove',function(e) {
            var pos = getTouchPosition(e);
            cwdref.x2 = pos[0];
            cwdref.y2 = pos[1];
            var len = Math.ceil(Math.sqrt((cwdref.x2-cwdref.x1)*(cwdref.x2-cwdref.x1)+(cwdref.y2-cwdref.y1)*(cwdref.y2-cwdref.y1)));
            $('#' + cwdref.id + ' table td').removeClass('striking bad good');
            var strCls = (Math.abs(cwdref.x1-cwdref.x2)==Math.abs(cwdref.y1-cwdref.y2) || cwdref.y1==cwdref.y2 || cwdref.x1==cwdref.x2)?'striking good':'striking bad';
            for (var i=0;i<=len;i++) {
                var cx = Math.round(cwdref.x2+(cwdref.x1-cwdref.x2)*i/len);
                var cy = Math.round(cwdref.y2+(cwdref.y1-cwdref.y2)*i/len);
                $("#"+cwdref.id+"_"+cx+"_"+cy).addClass(strCls);
            }
            $("#" + cwdref.id + " _"+cwdref.x1+"_"+cwdref.y1).addClass(strCls);
        });
        $('#' + cwdref.id + ' table').bind('touchend',function(e) {
            $('#' + cwdref.id + ' table td').removeClass('striking bad good');
            if (cwdref.pressed && (Math.abs(cwdref.x1-cwdref.x2)==Math.abs(cwdref.y1-cwdref.y2) || cwdref.y1==cwdref.y2 || cwdref.x1==cwdref.x2)) {
                cwdref.cross(cwdref.x1,cwdref.y1,cwdref.x2,cwdref.y2);
            }
            cwdref.pressed = false;
        });

        $('#' + cwdref.id + ' table td').bind('mouseover',function(e) {
            if (cwdref.pressed) {
                var id = $(this).attr('id');
                if (id.indexOf(cwdref.id)==0) {
                    var coords = id.substring(cwdref.id.length+1).split('_');
                    cwdref.x2 = parseInt(coords[0]);;
                    cwdref.y2 = parseInt(coords[1]);
                    var len = Math.sqrt((cwdref.x2-cwdref.x1)*(cwdref.x2-cwdref.x1)+(cwdref.y2-cwdref.y1)*(cwdref.y2-cwdref.y1));
                    $('#' + cwdref.id + ' table td').removeClass('striking bad good');
                    var strCls = (Math.abs(cwdref.x1-cwdref.x2)==Math.abs(cwdref.y1-cwdref.y2) || cwdref.y1==cwdref.y2 || cwdref.x1==cwdref.x2)?'striking good':'striking bad';
                    for (var i=0;i<=len;i++) {
                        var cx = Math.round(cwdref.x2+(cwdref.x1-cwdref.x2)*i/len);
                        var cy = Math.round(cwdref.y2+(cwdref.y1-cwdref.y2)*i/len);
                        $("#"+cwdref.id+"_"+cx+"_"+cy).addClass(strCls);
                    }
                    $("#"+cwdref-id+"_"+cwdref.x1+"_"+cwdref.y1).addClass(strCls);
                }
            }
        });
        this.load();
        setTimeout(this.id+'.saveTask();',this.saveInterval);
    };

    this.cross = function(x1,y1,x2,y2) {
        var cwdref = this;
        var len = Math.max(Math.abs(x1-x2),Math.abs(y1-y2))+1;
        var dx = 0;
        var dy = 0;
        var starti;
        var stopi;
        if (x1==x2) {
            dy = (y1<y2)?1:-1;
            starti = (dy==1)?3:7;
            stopi = (dy==1)?7:3;
        } else if (y1==y2) {
            dx = (x1<x2)?1:-1;
            starti = (dx==1)?5:1;
            stopi = (dx==1)?1:5;
        } else {
            dx = (x2>x1)?1:-1;
            dy = (y1<y2)?1:-1;
            if (dx==1 && dy==1) {
                starti = 4; stopi = 8;
            } else if (dx==1 && dy==-1) {
                starti = 6; stopi = 2;
            } else if (dx==-1 && dy==-1) {
                starti = 8; stopi = 4;
            } else if (dx==-1 && dy==1) {
                starti = 2; stopi = 6;
            }
        }
        var word = "";
        for (var i=0;i<len;i++) {
            var cx = x1+dx*i;
            var cy = y1+dy*i;
            word+= $("#"+this.id+"_"+cx+"_"+cy).text();
        }
        var revWord = this.reverse(word);
        var found = false;
        $("#"+this.id+" span").each(function(idx) {
            var text = $(this).text().trim();
            if (text==word || text==revWord) {
                $(this).addClass('found');
                $(this).detach().appendTo("#"+cwdref.id+"_fw");
                found = true;
            }
        });
        if (found) {
            for (var i=0;i<len;i++) {
                var cx = x1+dx*i;
                var cy = y1+dy*i;
                if (i>0) {
                    $("#"+this.id+"_"+cx+"_"+cy+" .cwd8d_cell"+stopi).show();
                }
                if (i<len-1) {
                    $("#"+this.id+"_"+cx+"_"+cy+" .cwd8d_cell"+starti).show();
                }
            }
            if (this.state.length>0) {
                this.state +=";";
            }
            this.state += x1+","+y1+","+x2+","+y2;
        }
        this.check_solution();
    };

    this.check_solution = function() {
        if ($('#'+this.id+'_nfw span').length==0) {
            $('#' + this.id + ' table td').each(function() {
                var td = $(this);
                if (td.children('.cwd8d_cell:visible').length==0) {
                    td.addClass('final');
                }
            });
        }
    };


    this.reverse = function(str) {
        var res = "";
        for (var i=str.length-1;i>=0;i--) res+= str[i];
        return res;
    };
    this.save = function() {
        if (this.supports_html5_storage()) {
            localStorage.setItem(this.id+'_state',this.state);
        }
    };
    this.saveTask = function() {
        this.save();
        setTimeout(this.id+'.saveTask();',this.saveInterval);
    };
    this.supports_html5_storage = function() {
        try {
            return 'localStorage' in window && window['localStorage'] !== null;
        } catch (e) {
            return false;
        }
    };
    this.load = function() {
        if (this.supports_html5_storage()) {
            var state = localStorage.getItem(this.id+'_state');
            if (state) {
                this.loadFrom(state);
            }
        }
    };

    this.clear = function() {
        if (this.supports_html5_storage()) {
            localStorage.removeItem(this.id+'_state');
        }
        window.location.reload();
    };

    this.loadFrom = function(state) {
        state = state.split(";");
        for (var i=0;i<state.length;i++) {
            var coords = state[i].split(",");
            if (coords.length==4) {
                this.cross(parseInt(coords[0]),parseInt(coords[1]),parseInt(coords[2]),parseInt(coords[3]));
            }
        }
    };
    this.getData = function() {
        return this.state;
    };
}
